using namespace std;

//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <stack>
#include <queue>
#include <tuple>
#include <map>

#define ll long long
#define ull unsigned ll
#define ld long double
#define pb push_back
#define mp make_pair
#define fori(i, n) for (int i = 0; i < n; ++i)
#define fori1(i, n) for (int i = 1; i <= n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sqr(x) (x)*(x)
#define db_(x) cout << x << ' ';
#define db(x) cout << x << '\n';cout.flush();
#define fastio ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
#define X first
#define Y second

struct SegTree {
    typedef pair<char, int> value_t;
    value_t neitral_v = mp('z' + 1, 0);

    static value_t sum_f(value_t a, value_t b) {
        if (a.X < b.X) {
            return a;
        } else if (a.X > b.X) {
            return b;
        }
        return a.Y < b.Y ? b : a;
    }

    SegTree(int n) : nn(pow(2, floor(log2(n - 1)) + 1)), ar(nn * 2, neitral_v) {
        fori(i, n) {
            ar[nn - 1 + i] = mp('z', i);
        }
        for (int i = nn - 2; i >= 0; --i) {
            ar[i] = sum_f(ar[i * 2 + 1], ar[i * 2 + 2]);
        }
    }

    value_t ssum(int l, int r) {
        return ssum(l, r, 0, 0, nn);
    }

    value_t ssum(int l, int r, int x, int lx, int rx) {
        if (rx <= l || r <= lx) {
            return neitral_v;
        }
        if (l <= lx && rx <= r) {
            return ar[x];
        }
        int m = (lx + rx) / 2;
        return sum_f(ssum(l, r, x * 2 + 1, lx, m), ssum(l, r, x * 2 + 2, m, rx));
    }

    void sset(int l, int r, value_t v) {
        sset(l, r, 0, 0, nn, v);
    }

    void sset(int l, int r, int x, int lx, int rx, value_t v) {
        if (l <= lx && rx <= r) {
            ar[x] = v;
            return;
        }
        if (l >= rx || r <= lx) {
            return;
        }
        int m = (lx + rx) / 2;
        sset(l, r, x * 2 + 1, lx, m, v);
        sset(l, r, x * 2 + 2, m, rx, v);
        ar[x] = sum_f(ar[x * 2 + 1], ar[x * 2 + 2]);
    }

    int nn;
    vector<value_t> ar;
};

void make_ans(SegTree &st, vector<char> &ans, int l, int r) {
    if (l + 1 > r) {
        return;
    }
    auto v = st.ssum(l, r);
    ans.pb(v.first);
    if (l + 1 == r) {
        return;
    }

    make_ans(st, ans, l, v.second);
    make_ans(st, ans, v.second + 1, r);
}

void solver() {
    string s;
    cin >> s;

    SegTree segTree(s.size());
    for (int i = 0; i < s.size(); ++i) {
        segTree.sset(i, i + 1, mp(s[i], i));
    }

    vector<char> ans;
    make_ans(segTree, ans, 0, s.size());
    for (char c : ans) {
        cout << c;
    }
}

int main() {
//    fastio;
    solver();
    cout << "\n";
}