using namespace std;

//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <stack>
#include <queue>
#include <tuple>
#include <map>

#define ll long long
#define ull unsigned ll
#define ld long double
#define pb push_back
#define mp make_pair
#define fori(i, n) for (int i = 0; i < n; ++i)
#define fori1(i, n) for (int i = 1; i <= n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sqr(x) (x)*(x)
#define db_(x) cout << x << ' ';
#define db(x) cout << x << '\n';cout.flush();
#define fastio ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
#define X first
#define Y second

bool dfs(int n, const vector<vector<int>> &egs, vector<int> &marks, vector<int> &comps, int u, int mr) {
    if (marks[u] > 0) { return marks[u] == mr; }
    comps.pb(u);
    marks[u] = mr;
    bool ok = true;
    for (int v : egs[u]) {
        ok = ok && dfs(n, egs, marks, comps, v, 3 - mr);
    }
    return ok;
}

int solver() {
    int n, m;
    cin >> n >> m;
    vector<int> cls(n);
    vector<bool> reprint(n);
    fori(i, n) {
        cin >> cls[i];
    }
    fori(i, n) {
        int t;
        cin >> t;
        reprint[i] = t == 1;
    }


    vector <vector<int>> egs(n);
    fori(i, m) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        egs[u].pb(v);
        egs[v].pb(u);
    }

    vector<int> marks(n);
    vector <vector<int>> compss;
    bool ok = true;
    fori(u, n) {
        if (marks[u] == 0) {
            compss.emplace_back();
            ok = ok && dfs(n, egs, marks, compss.back(), u, 1);
        }
    }

    if (!ok) {
        return -1;
    }

    int ans = 0;
    for (const auto &comps: compss) {
        int nrc = 0;
        for (int u : comps) {
            if (!reprint[u] && nrc == 0) {
                nrc = marks[u] == cls[u] ? 1 : 2;
            } else if (!reprint[u]) {
                if ((marks[u] == cls[u]) != (nrc == 1)) {
                    return -1;
                }
            }
        }

        if (nrc == 0) {
            int v1 = 0;
            for (int u : comps) {
                v1 += marks[u] == cls[u];
            }
            int v2 = (int) comps.size() - v1;
            ans += min(v1, v2);
        } else {
            for (int u : comps) {
                ans += (marks[u] == cls[u]) != (nrc == 1);
            }
        }
    }
    return ans;
}

int main() {
//    fastio;
    cout << solver() << "\n";
}